#ifndef FITNESS_H
#define FITNESS_H

#include <eo>
#include <iostream>   // cout
#include <fstream>
#include <vector>

using namespace std;

#define K 10

// REPRESENTATION 
//-----------------------------------------------------------------------------
// define your individuals

class MyIndividual : public EO<double> {

public:
  
  int operator[](int i) const { return classes[i]; } 
  int& operator[](int i)  { return classes[i]; } 

  void resize(int N) { classes.resize(N);  }
  unsigned size() const { return classes.size(); }

  virtual std::string className() const {
    return "MyIndividual";
  }
 
  virtual void printOn(std::ostream& os) const {
    EO<double>::printOn(os);
    for (unsigned i=0; i<classes.size(); i++) 
      os << " " << classes[i]; 
  }
  
  virtual void readFrom(std::istream& is)   {
    // not implemented
  }

private:
  vector<int> classes;
}; 




// FITNESS FUNCTION 
class MyFitness :  public eoEvalFunc<MyIndividual> {

public:
  MyFitness(string _fileName) : fileName(_fileName) {
    ifstream file (fileName.c_str()); 
    int N; int vaha; 
    file >> N;
    for (int i=0; i<N; i++) {
      file >> vaha;
      predmety.push_back(vaha); 
    } 

    hromadky.resize(10);
  };


  // todo: prepiste tento operator, aby pocital fitness k problemu "hromadkovani"
   virtual void operator() (MyIndividual& ind)   {
     if (ind.invalid()) {
       
       vyprazdni(); 

       for (unsigned i=0; i<ind.size(); i++) {
	 hromadky[ ind[i] ] += predmety[ i ]; 
       }
       
       int min, max;
       min = max = hromadky[0]; 
       for (unsigned i=1; i<hromadky.size(); i++) {
	 if (hromadky[i] < min) min = hromadky[i];
	 if (hromadky[i] > max) max = hromadky[i];
       }

       ind.fitness( (min - max)  ); 
     }
   };

  void vyprazdni() {
    for (unsigned i=0; i<hromadky.size(); i++) 
      hromadky[i] = 0;
  };
     

 private:
  string fileName;
  vector<int> predmety; 
  vector<int> hromadky;
};

#endif
