#include "fitness.h"


class MyXover : public eoQuadOp<MyIndividual> {

public:  
  string className() const { return "MyCrossover"; }

  bool operator()(MyIndividual& ind1, MyIndividual & ind2) 
  {
    int crosspoint1 = rng.random( ind1.size() ); 
    int crosspoint2 = rng.random( ind1.size() ); 

    for (int i=crosspoint1; i<crosspoint2; i++) {
      int buff = ind1[i];
      ind1[i] = ind2[i];
      ind2[i] = buff;
    }
    
    return true; // vraci true, pokud alespon jeden z jedincu byl zmenen 
  }
};


class MyMut: public eoMonOp<MyIndividual>
{
public:
  
  string className() const { return "MyMutation"; }


  bool operator()(MyIndividual & ind) {
    
    for (int i=0; i<5; i++) {
      int change = rng.random( ind.size() );
      ind[change] = rng.random(  K ); 
    }

    return true; // vraci true, pokud byl jedinec  zmenen 
  }

};

class MyMut2: public eoMonOp<MyIndividual>
{
public:
  
  // in contructor we need to read the input file
  MyMut2(string _fileName) : fileName(_fileName) {
    ifstream file (fileName.c_str()); 
    int N; int vaha; 
    file >> N;
    for (int i=0; i<N; i++) {
      file >> vaha;
      predmety.push_back(vaha); 
    } 

    hromadky.resize(10);
    pocty.resize(10);
  };


  string className() const { return "MyMutation2"; }


  bool operator()(MyIndividual & ind) {
    
    vyprazdni();
    
    for (unsigned i=0; i<ind.size(); i++) {
      hromadky[ ind[i] ] += predmety[ i ]; 
      pocty [ ind[i] ]++;
    }
    
    int min, max;
    min = max = 0; 
    for (unsigned i=1; i<hromadky.size(); i++) {
      if (hromadky[i] < hromadky[min]) min = i; 
      if (hromadky[i] > hromadky[max]) max = i;
    }
  
    // prendej jeden predmet z nejmensi hromadky do nejvetsi
    int index = rng.random( pocty[max] ); 

    for (unsigned i=0; i<ind.size(); i++) 
      if (ind[i] == max) 
	if (index == 0) 
	  ind[i] = min; // presun do nejmensi
	else
	  index--; 
    
    
    return true; // vraci true, pokud byl jedinec  zmenen 
  }

  void vyprazdni() {
    for (unsigned i=0; i<hromadky.size(); i++) {
      hromadky[i] = 0;
      pocty[i] = 0; 
    }
  };
  

private:
  string fileName;
  vector<int> predmety; 
  vector<int> hromadky;
  vector<int>  pocty;
};
